# -*- coding: utf-8 -*-
"""
(c)2012-2013 ЗАО "РИПАС"
www.ripas.ru
"""
from RoadCentre import plugins
import gui

if hasattr(plugins,'EditorPlugin') and hasattr(plugins,'SpectrPlugin'):
    import editor, settings
    from PythonQt.QtGui import QIcon
    from PythonQt import Qt

    tb=gui.mainWindow.addToolBar(u'Редактор')
    tb.objectName='toolBarEditor'

    action = tb.addAction(u'Режим перемещения')
    action.checkable=1
    action.icon=QIcon(':resources/objects_move.png')
    action.connect('triggered(bool)', editor.setObjectsMoveMode)
    action.statusTip = action.toolTip = u'Включить/Выключить режим перемещения объектов'

    action = tb.addAction(u'Добавить объект')
    action.icon=QIcon(':resources/add_object.png')
    action.connect('triggered()', editor.addObject)
    action.statusTip = action.toolTip = u'Добавить новый объект'

    if hasattr(plugins,'CamLayerPlugin'):
        action = tb.addAction(u'Добавить камеру')
        action.icon=QIcon(':resources/add_camera.png')
        action.connect('triggered()', editor.addCamera)
        action.statusTip = action.toolTip = u'Добавить новую камеру'

    actionOpen=gui.mainWindow.findChild('QAction','actionOpen')
    action = Qt.QAction(u'Создать',gui.mainWindow)
    action.icon=QIcon(':resources/new_project.png')
    action.connect('triggered()', editor.createProject)
    action.statusTip = action.toolTip = u'Создать новый проект'
    menuFile=None
    try:
        menuFile=gui.mainWindow.findChild('QMenu','menuFile')
        menuFile.insertAction(menuFile.actions()[0],action)
    except:
        pass

    mainToolbar=gui.mainWindow.findChild('QToolBar','mainToolBar')
    if not mainToolbar:
        mainToolbar=tb
        actionOpen=0
    mainToolbar.insertAction(actionOpen,action)

    mode = settings.value('ExpertMenuMode','','')
    if mode.lower() in ('true', 'yes', 'y', 'ok') or (mode.isdigit() and int(mode)):
        menuSettings=gui.mainWindow.findChild('QMenu','menuSettings')
        if menuSettings:
            menuSettings.addAction(u'Настройки проекта').connect('triggered()',editor.editProjectSettins)
            menuSettings.addAction(u'Настройки пользователя').connect('triggered()',plugins.EditorPlugin.editUserSettings)
            menuSettings.addAction(u'Настройки системы').connect('triggered()',plugins.EditorPlugin.editSystemSettings)

    menuMap=gui.mainWindow.findChild('QMenu','menuMap')
    if menuMap:
        menuMap.addAction(u'Настройки карты').connect('triggered()',editor.editOsmProperies)
        menuMap.addAction(u'Предустановленные виды').connect('triggered()',editor.editPresets)

    fileMenu=gui.mainWindow.findChild('QMenu','menuFile')
    if fileMenu:
        action=fileMenu.addAction(u'Свойства проекта')
        action.connect('triggered()',editor.editProject)
        fileMenu.insertAction(gui.mainWindow.findChild('QAction','actionExit'),action)

    from menu import Menu
    if hasattr(plugins,'SpectrPlugin'):
        Menu.devClassMenus['Spectr::Light'].appendCustomAction()
        a=Menu.devClassMenus['Spectr::Light'].appendCustomAction(u'Удалить',editor.removeControllers).setData('URes/DEV_REMOVE')
        a=Menu.devClassMenus['Spectr::Light'].appendCustomAction(u'Свойства',editor.controllerProperties).setData('URes/DEV_PROP')

    plugins.EditorPlugin.connect('objectEdited(QObject*)',editor.objectEdited)

    plugins.EditorPlugin.initCloseHandler()


    gui.msgOk(u'Инициализации модуля "Редактор проекта" выполнена')
